/* This file is generated by  NSL3.0 preprocessor*/

/* SCCS  %W%---%G%--%U% */
/* old kversion @(#)PFC.mod	1.8 --- 08/05/99 -- 13:56:29 : jversion  @(#)PFC.mod	1.2---04/23/99--18:39:37 */
// Import statements
 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 


//
//  Module: PrefrontalCortex
//
//   From PAPER3.TXT, 3.2:
//    The Select Target schema is found within the prefrontal cortex (PFC)
//    in our model.
//   From PAPER3.TXT, 3.5:
//    We place the Issue GO Signal schema within prefrontal cortex.
//   From PAPER3.TXT, 3.4:
//    Thus, we place the Remap Targets schema within the BG.
//    The BG performs this remapping operation upon all potential saccade
//    targets simultaneously and relays the remapped target information to
//    prefrontal cortex and parietal cortex via thalamic relay neurons.

// INPUT:
//  LIPvis
//    MATRIX(LIPvis,CorticalArraySize,CorticalArraySize);
//  LIPmem
//    MATRIX(LIPmem,CorticalArraySize,CorticalArraySize);
//  ThPFCmem
//    MATRIX(ThPFCmem,CorticalArraySize,CorticalArraySize);
//
//  Description:
//   From PAPER3.TXT, 3.7:
//    LIP provides a visual buffer signal that is active for visual targets
//    as well as memory targets.
//   From PAPER3.TXT, 3.1:
//    Our model includes both visually-activated (LIPvis) and memory neurons
//    in LIP (LIPmem).  The visual neurons only respond to visual stimuli
//    (Gnadt & Andersen, 1988) and receive direct visual input in our model.
//    The memory response cells fire continuously during the delay portion
//    of a delay saccade task.
//   From PAPER3.TXT, 3.1:
//    These cells fire even if the stimulus never
//    enters their receptive field when a second saccade is arranged so that
//    it matched the cell's receptive field.  We propose a memory loop is
//    established between these cells in LIP and mediodorsal thalamus.


// OUTPUT:
//  PFCfovea
//    MATRIX(PFCfovea,CorticalArraySize,CorticalArraySize);
//  PFCgo
//    MATRIX(PFCgo,CorticalArraySize,CorticalArraySize);
//  PFCmem
//    MATRIX(PFCmem,CorticalArraySize,CorticalArraySize);
//
//  Description:
//   From PAPER3.TXT, 3.2:
//    Foveal inhibition is represented in prefrontal cortex by PFCfovea which
//    receives its input from the central element of the visual cells in LIP
//    (LIPvis).
//   From PAPER3.TXT, 3.5:
//    We place the Issue GO Signal schema within prefrontal cortex.
//    We will use a neuronal layer (PFCgo) to pass the trigger signal to FEF,
//    LIP and to the BG.  This signal will be used by the receiving layers
//    to increase their activation for the selected saccade target to cause
//    the activation through to the superior colliculus to effect the
//    saccade selected by prefrontal cortex.
//   From PAPER3.TXT, 3.2:
//    PFCmem will provide the next saccade target, if one exists.

 public class PFC extends NslModule/*(int array_size)*/ {
    public NslDinDouble2 LIPvis_in ; /* (array_size,array_size) */
    public NslDinDouble2 LIPmem_in ; /* (array_size,array_size) */
    public NslDinDouble2 ThPFCmem_in ; /* (array_size,array_size)   */

    public NslDoutDouble2 PFCfovea_out ; /*(array_size,array_size)   */
    public NslDoutDouble2 PFCgo_out ; /* (array_size,array_size)   */
    public NslDoutDouble2 PFCmem_out ; /*  (array_size,array_size) */

    private PFCfovea PFCfovea1 ; /* (array_size)  */
    private PFCgo PFCgo1 ; /* (array_size)   */
    private PFCmem PFCmem1 ; /* (array_size)  */
    private PFCseq PFCseq1 ; /* (array_size)   */
    private NslInt0 FOVEAX ; /*()*/
    private NslInt0 FOVEAY ; /*()*/

public  void initModule()
{
    FOVEAX.set((NslInt0)nslGetValue("crowleyTop.FOVEAX")) /*rule 114 */;
    FOVEAY.set((NslInt0)nslGetValue("crowleyTop.FOVEAY")) /*rule 114 */;  
}
  
public  void makeConn(){
    // module inputs to leaf inputs
    nslConnect(LIPvis_in,PFCfovea1.LIPvis_in);
    nslConnect(LIPmem_in,PFCgo1.LIPmem_in);
    nslConnect(ThPFCmem_in,PFCmem1.ThPFCmem_in);
    nslConnect(LIPmem_in,PFCmem1.LIPmem_in);
    nslConnect(LIPvis_in,PFCseq1.LIPvis_in);

    // leaf internslConnectections
    nslConnect(PFCfovea1.PFCfovea_out,PFCgo1.PFCfovea_in);
    nslConnect(PFCseq1.PFCseq_out,PFCgo1.PFCseq_in);

    nslConnect(PFCseq1.pfcseq_out,PFCmem1.pfcseq_in);
    nslConnect(PFCmem1.PFCmem_out,PFCseq1.PFCmem_in);
    nslConnect(PFCfovea1.PFCfovea_out,PFCseq1.PFCfovea_in);

    // leaf outputs to module outputs
    nslConnect(PFCfovea1.PFCfovea_out,PFCfovea_out);
    nslConnect(PFCgo1.PFCgo_out,PFCgo_out);

    nslConnect(PFCmem1.PFCmem_out,PFCmem_out);
}

	/* nslInitTempModule inserted by NPP */
public void nslInitTempModule() {
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic instantiation statements */
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempRun inserted by NPP */
public void nslInitTempRun() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempTrain inserted by NPP */
public void nslInitTempTrain() {
	/* Initialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	/* constructor and related methods */
	/* nsl declarations */
	int array_size;

	 /*GENERIC CONSTRUCTOR:   */
	 public PFC(String nslName, NslModule nslParent,int array_size) {
		super(nslName, nslParent);
		this.array_size = array_size;
		initSys();
		makeInst(nslName, nslParent,array_size);
	}
	public void makeInst(String nslName, NslModule nslParent,int array_size){ 
	 LIPvis_in=new NslDinDouble2 ("LIPvis_in",this,array_size,array_size); //NSLDECLS 
	 LIPmem_in=new NslDinDouble2 ("LIPmem_in",this,array_size,array_size); //NSLDECLS 
	 ThPFCmem_in=new NslDinDouble2 ("ThPFCmem_in",this,array_size,array_size); //NSLDECLS 
	 PFCfovea_out=new NslDoutDouble2 ("PFCfovea_out",this,array_size,array_size); //NSLDECLS 
	 PFCgo_out=new NslDoutDouble2 ("PFCgo_out",this,array_size,array_size); //NSLDECLS 
	 PFCmem_out=new NslDoutDouble2 ("PFCmem_out",this,array_size,array_size); //NSLDECLS 
	 PFCfovea1=new PFCfovea ("PFCfovea1",this,array_size); //NSLDECLS 
	 PFCgo1=new PFCgo ("PFCgo1",this,array_size); //NSLDECLS 
	 PFCmem1=new PFCmem ("PFCmem1",this,array_size); //NSLDECLS 
	 PFCseq1=new PFCseq ("PFCseq1",this,array_size); //NSLDECLS 
	 FOVEAX=new NslInt0 ("FOVEAX",this); //NSLDECLS 
	 FOVEAY=new NslInt0 ("FOVEAY",this); //NSLDECLS 
	}
	/* end of automatic declaration statements */
} //end class
